#ifndef GMODE13
#define GMODE13

#include <conio.h>
#include <bios.h>
#include <dos.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "bmp_func.h"
enum{
   COPY_PUT,
   XOR_PUT,
   OR_PUT,
   AND_PUT,
   NOT_PUT
};

char CurrentColor=7;
int mx, my, but;                    //mouse_x, mouse_y, button_state
char CHARSET[256][64];

void moff();
void mon();
void mread();

void vga256(void);
void wbar(int left, int top, int right, int bottom);
void wcls(int c);
void wfastputpixel(int x, int y);
void wfline(int startx, int starty, int endx, int endy);
void wgetimage(int left, int top, int right, int bottom, char* bitmap);
int wgetpixel(int x, int y);
void wgetrgb(char color, ARGBQUAD* RGB);
void wgetpalette(ARGBQUAD* Palette);
long wimagesize(int left, int top, int right, int bottom);
void winitcharset(void);
void woutchar(int left, int top, char Letter);
void wputimage(int left, int top, char *bitmap, int op);
void wrectangle(int left, int top, int right, int bottom);
void wsetcolor(char color);
int wgettextheight(char* Text, void* endptr);
int wgettextwidth(char* Text, void* endptr);

void wgetimage(int left, int top, int right, int bottom, char* bitmap){
   int dest_segm = FP_SEG(bitmap);
   int dest_offs = FP_OFF(bitmap);
   int width = right-left+1;
   int height = bottom-top+1;
   bitmap[0] = width;
   bitmap[1] = height;
   dest_offs += 2;
   for(int y=top; y<=bottom; y++){
       int source_offs =  y*320 + left;
       asm{
       //save segments
           push cx
           push di
           push ds
           push es
           push si
       //registers adjustind
           push 0x0A000          //source memory segment
           pop ds
           push source_offs
           pop si

           push dest_segm        //destination segment
           pop es
           push dest_offs
           pop di

           mov cx, width
           cld
           rep movsb

       //restore segments
           pop si
           pop es
           pop ds
           pop di
           pop cx
       }
       dest_offs += width;
   }
}
void wputimage(int left, int top, char *bitmap, int op){
   int source_segm = FP_SEG(bitmap);
   int source_offs = FP_OFF(bitmap);
   int width = bitmap[0];
   int height = bitmap[1];
   source_offs += 2;
   //COPY_PUT
   if(op==COPY_PUT){
       for(int y = top; y < top+height; y++){
           int dest_offs =  y*320 + left;
           asm{
           //save segments
               push cx
               push di
               push ds
               push es
               push si
           //registers adjustind
               push 0x0A000          //dest memory segment
               pop es
               push dest_offs
               pop di

               push source_segm        //src segment
               pop ds
               push source_offs
               pop si

               mov cx, width
               cld
               rep movsb

           //restore segments
               pop si
               pop es
               pop ds
               pop di
               pop cx
           }
           source_offs += width;
       }
   }
   if(op==XOR_PUT){
       long is = wimagesize(left, top, left+width-1, top+height-1);
       char* screen = new char[is];
       wgetimage(left, top, left+width-1, top+height-1, screen);
       for(int i=3; i<is; i++){
           screen[i] ^= bitmap[i];
       }
       wputimage(left, top, screen, COPY_PUT);
       delete [] screen;
   }
   if(op==OR_PUT){
       long is = wimagesize(left, top, left+width-1, top+height-1);
       char* screen = new char[is];
       wgetimage(left, top, left+width-1, top+height-1, screen);
       for(int i=3; i<is; i++){
           screen[i] |= bitmap[i];
       }
       wputimage(left, top, screen, COPY_PUT);
       delete [] screen;
   }
   if(op==AND_PUT){
       long is = wimagesize(left, top, left+width-1, top+height-1);
       char* screen = new char[is];
       wgetimage(left, top, left+width-1, top+height-1, screen);
       for(int i=3; i<is; i++){
           screen[i] &= bitmap[i];
       }
       wputimage(left, top, screen, COPY_PUT);
       delete [] screen;
   }
   if(op==NOT_PUT){
       long is = wimagesize(left, top, left+width-1, top+height-1);
       char* not_bitmap = new char[is];
       not_bitmap[0] = bitmap[0];
       not_bitmap[1] = bitmap[1];
       for(int i=3; i<is; i++){
           not_bitmap[i] = ~bitmap[i];
       }
       wputimage(left, top, not_bitmap, COPY_PUT);
       delete [] not_bitmap;
   }
   return;
}
void wgetrgb(char color, ARGBQUAD* RGB){
   char R, G, B;
   asm{
       mov ah, 0x10
       mov al, 21
       mov bh, 0
       mov bl, color
       int 0x10
       mov G, ch
       mov B, cl
       mov R, dh
   }
   RGB->rgbRed = R*4;
   RGB->rgbBlue = B*4;
   RGB->rgbGreen = G*4;
   RGB->rgbReserved = 0;
}
void wgetpalette(ARGBQUAD* Palette){
   char far* buf=NULL;
   int i, k;
   buf = new char[256*3];
   if(buf==NULL){
       textmode(C80);
       printf("\nNot enough memory.\n");
       return;
   }
   for(i=0; i<256*3; i++) buf[i]=0;
   int offs = FP_OFF(buf);
   int segm = FP_SEG(buf);
   asm{
       //save segments
       push es
       push dx
       push ax
       push bx
       push cx
       //get palette
       mov ax, segm              //init es - segment of palette table
       push ax
       pop es
       mov dx, offs              //init dx - offset of palette table
       mov ah, 0x10              //BIOS graph function
       mov al, 0x17              //get palette subfunction
       mov bx, 0x0000            //first color number
       mov cx, 0x0100            //colors number to read
       int 0x10
       //restore segments
       pop cx
       pop bx
       pop ax
       pop dx
       pop es
   }
   for(i=0, k=0; i<256*3; i+=3, k++){
       Palette[k].rgbRed = 4*buf[i];
       Palette[k].rgbGreen = 4*buf[i+1];
       Palette[k].rgbBlue = 4*buf[i+2];
       Palette[k].rgbReserved = 0;
   }
   delete [] buf;
}
long wimagesize(int left, int top, int right, int bottom){
   return( long(right - left + 1) * long(bottom - top + 1) + 2L);
}
void winitcharset(){
   for(int c=0; c<256; c++){
       gotoxy(1, 1);
       if( c==7 || c==8 || c==9 || c==10 || c==13 ) printf(" ");
       else printf("%c", c);
       for(int x=0; x<8; x++){
           for(int y=0; y<8; y++){
               CHARSET[c][x+y*8] = wgetpixel(x, y);
           }
       }
   }
}
void wsetcolor(char NewColor){
   CurrentColor = NewColor;
}
void vga256(){
   //set graphmode 13 and init charset
   asm{
	mov	ax, 0x0013
	int	0x10
   }
   winitcharset();
}
void wfastputpixel(int x, int y){
   if(x<0 || y<0 || x>=320 || y>=200) return;
   int offs_addr =  y*320 + x;
   asm{
       //save segments
       push ax
       push di
       push es

       //plot
       push 0x0A000
       pop es

       mov al, CurrentColor
       mov di, offs_addr
       mov [es:di], al

       //restore segments
       pop es
       pop di
       pop ax

   }
}
int wgetpixel(int x, int y){
   if(x<0 || y<0 || x>=320 || y>=200) return(0);
   int offs_addr =  y*320 + x;
   unsigned char c;
   asm{
       //save segments
       push ax
       push di
       push es

       //get pixel
       push 0x0A000
       pop es

       mov di, offs_addr
       mov al, [es:di]
       mov c, al

       //restore segments
       pop es
       pop di
       pop ax
   }
   return(c);
}
void wfline(int startx, int starty, int endx, int endy){
   int x=0, y=0, delta_x=0, delta_y=0;
   int t, distance;
   int incx, incy;
   delta_x = endx - startx;
   delta_y = endy - starty;
   if(delta_x > 0) incx = 1;
   else if(delta_x == 0) incx = 0;
   else incx = -1;
   if(delta_y > 0) incy = 1;
   else if(delta_y == 0) incy = 0;
   else incy = -1;
   delta_x = abs(delta_x);
   delta_y = abs(delta_y);
   if(delta_x > delta_y) distance = delta_x;
   else distance = delta_y;
   for(t=0; t<=distance+1; t++){
       wfastputpixel(startx, starty);
       x += delta_x;
       y += delta_y;
       if(x > distance){
           x -= distance;
           startx += incx;
       }
       if(y > distance){
           y -= distance;
           starty += incy;
       }
   }
}
void wrectangle(int left, int top, int right, int bottom){
   wfline(left, top, right, top);
   wfline(right, top, right, bottom);
   wfline(right, bottom, left, bottom);
   wfline(left, bottom, left, top);
}
void wbar(int left, int top, int right, int bottom){
   for(int y=top; y<=bottom; y++){
       wfline(left, y, right, y);
   }
}
void woutchar(int left, int top, char Letter){
   for(int x=0; x<8; x++){
       for(int y=0; y<8; y++){
           if( CHARSET[Letter][x+y*8]==7 ){
               wfastputpixel(left+x, top+y);
           }
       }
   }
}
void wouttextxy(int left, int top, char* Text, void* endptr){
   if(endptr!=NULL) return;
   int N = strlen(Text);
   for(int i=0; i<N; i++){
       woutchar( left+i*8, top, Text[i] );
   }
}
int wgettextheight(char* Text, void* endptr){
   if(endptr!=NULL) return(0);
   if(Text!=NULL){
       return(8);
   }
   return(0);
}
int wgettextwidth(char* Text, void* endptr){
   if(endptr!=NULL) return(0);
   return( 8*strlen(Text) );
}

void mread(){
   but = 0;
   asm{
       mov      ax, 3
       int      0x33                    //get mouse state
       mov      mx, cx
       mov      my, dx
       and      bx, 0x1
       jz       exit
       mov      but, 1
   }
   exit:
   mx /= 2;
}
void minit(){
   asm{
	mov	ax, 0			//init mouse
	int	0x33
   }
}
void mon(){
   asm{
       mov     ax, 0x01                 //show mouse
       int     0x33
   }
}
void moff(){
   asm{
        mov     ax, 0x02                 //hide mouse
        int     0x33
   }
}
void wcls(int color){
   asm{
       push ax
       push cx
       push di
       push es

       push 0x0A000
       pop es
       push 0
       pop di

       mov cx, 320*200
       mov ax, color
       rep stosb

       pop es
       pop di
       pop cx
       pop ax
   }
}
#endif