#include <conio.h>
#include <string.h>
#include <stdio.h>
#include <ctype.h>
#include <stdlib.h>
#include <dir.h>
#include <dos.h>
#include <bios.h>
#include <math.h>
#include "gmode_13.cpp"
#include "bmp_func.h"
#define ColorBarWidth 64
#define ColorBarCellSize 4
#define InputWindowLength 200
#define InputWindowWidth 100
#define MaxXCellsVisible 40
#define MaxYCellsVisible 40
#define MaxXCellVisibleMinimized 40
#define MaxYCellVisibleMinimized 40
#define MYPICFILETYPE 0      //my own method
#define BMPFILETYPE 1        //bmp
//----------Functions descriptions---------------------------------------
void DrawColorBar(void);
void DrawKeyLine(void);
void DrawDefinedColorBar(void);
void Edit(int*, int, int, int, int);
void Edit(char*, int, int, int, int);
void Input(char* Title, int* Result);
void Input(char* Title, char* Result);
void clear_keyboard_buffer(void);
int Load(void);
void New(void);
void SavePicFile(char* FileName);
void LoadPicFile(char* FileName);
void SaveBmpFile(char* FileName);
void LoadBmpFile(char* FileName);

float DifferenceTime(struct time* Begin, struct time* End);
void DrawVertScrollBar();
void DrawHorizScrollBar();
//---------Class definitions----------------------------------------------

class PaintClass{
public:
   int x,y;
   static ARGBQUAD Palette[256];
   static int CellSize;
   static int MinimizedTop;
   static int MinimizedLeft;
   static int CurrentColor;
   //static int LeftVisible;
   //static int RightVisible;
   int MemoryAllocationError;
   int LastAllocatedBlock;
   unsigned char **Cell;
   PaintClass(int Argx, int Argy);
   ~PaintClass();
   void SetCell(int Color);
   void RefreshScreen(void);
   int Save(void);
   int Load(void);
};

//---------Global variables definitions---------------------------------
int PaintClass::CellSize=4;
int PaintClass::MinimizedTop;
int PaintClass::MinimizedLeft;
int PaintClass::CurrentColor;
ARGBQUAD PaintClass::Palette[256];
const int Maxx=319, Maxy=199, maxcolor=255;
PaintClass* Paint;
int FileType=MYPICFILETYPE;
const int KeyLength=40;       //used in 'DrawKeyLine' procedure
const int KeyNums=4;
int DefinedColor[16];
int FileTypeNumber=2;
char FileTypeName[][4]={
   "PIC",
   "BMP"
};
char Keys[][5]={
   "Exit",
   "Save",
   "Load",
   "New"
};
//--------Function definitions----------------------------------------------
void clear_keyboard_buffer(void){
   asm{
      cli
      sub ax,ax
      mov es,ax
      mov al,es:[0x41a]
      mov es:[0x41c],al
      sti
   }
}
//----------------------------------------------------------------------
PaintClass::PaintClass(int Argx, int Argy){
   x=Argx;
   y=Argy;
   Cell=NULL;
   Cell = new unsigned char*[x];            //ᮧ  ⮫殢
   if(Cell==NULL){
       textmode(C80);
       printf("Sorry, not enough memory to make %d * %d image", x, y);
       exit(1);
   }
   for(int cx=0; cx<x; cx++){
       Cell[cx]=NULL;
       Cell[cx]=new unsigned char[y];     // y ᨬ  
       if(Cell[cx]==NULL){
           textmode(C80);
           printf("Sorry, not enough memory to make %d * %d image", x, y);
           exit(1);
       }

   }
   for(int k=0; k<16; k++){
      DefinedColor[k]=k;
   }
   MinimizedTop=0;
   MinimizedLeft=202;
   CurrentColor=0;
   SetCell(WHITE);
   RefreshScreen();
}
//----------------------------------------------------------------------
PaintClass :: ~PaintClass(){
   for(int cx=0; cx<x; cx++){
       delete [] Cell[cx];
   }
   delete [] Cell;
}
//----------------------------------------------------------------------
void PaintClass :: SetCell(int Color){
   for(int cx=0; cx<x; cx++){
       memset(Cell[cx], Color, y);
   }
}
//----------------------------------------------------------------------
void PaintClass :: RefreshScreen(void){
   moff();
   wcls(0);
   //㥬 ᭠砫 訥 窨,  ⮫쪮
   //MaxXCellsVisible    X        MaxYCellsVisible    Y
   for(int cx=0; cx<x && cx<MaxXCellsVisible; cx++){
       for(int cy=0; cy<y && cy<MaxYCellsVisible; cy++){
	   wsetcolor( Cell[cx][cy] );
	   wbar(cx*CellSize, cy*CellSize, (cx*CellSize+CellSize-2), (cy*CellSize+CellSize-2) );
       }
   }
   for(cx=0; cx<x && cx<MaxXCellVisibleMinimized; cx++){
       for(int cy=0; cy<y && MaxYCellVisibleMinimized; cy++){
	   wsetcolor( Cell[cx][cy] );
	   wfastputpixel(MinimizedLeft+cx, MinimizedTop+cy );
       }
   }
   wsetcolor(WHITE);
   wfline(200, 0, 200, 200);
   DrawColorBar();
   DrawKeyLine();
   DrawDefinedColorBar();
   mon();
}
int PaintClass::Load(void){
   char LoadFileName[256];
   Input("Input file name", LoadFileName);
   struct ffblk MyFfblk;
   int NewX, NewY;
   if(findfirst(LoadFileName, &MyFfblk, FA_ARCH)!=0 ){
       wouttextxy( Maxx/2-wgettextwidth("Load file not found", NULL)/2, (Maxy-InputWindowWidth)/2+ 5*InputWindowWidth/6, "Load file not found", NULL);
       while( !kbhit() );
       Paint->RefreshScreen();
       mon();
       return(0);
   }
   switch(FileType){
       case MYPICFILETYPE:
	   LoadPicFile(LoadFileName);
	   break;
       case BMPFILETYPE:
           LoadBmpFile(LoadFileName);
	   break;
   }
   return(1);
}
void DrawVertScrollBar(){
   return;
}
void DrawHorizScrollBar(){
   return;
}
void ErrorMsg(char* msg){
   wouttextxy( Maxx/2-wgettextwidth(msg, NULL)/2, (Maxy-InputWindowWidth)/2+ 5*InputWindowWidth/6, msg, NULL);
   while( !kbhit() );
   Paint->RefreshScreen();
   mon();
}
//----------------------------------------------------------------------
int PaintClass::Save(void){
   char SaveFileName[256];
   Input("Input save file name", SaveFileName);
   switch(FileType){
       case MYPICFILETYPE:
	   SavePicFile(SaveFileName);
	   break;
       case BMPFILETYPE:
           SaveBmpFile(SaveFileName);
	   break;
   }
   return (1);
}
//------------------------------------------------------------------------
void SavePicFile(char* SaveFileName){
   FILE* SaveFilePtr=fopen(SaveFileName, "wt");
   if(SaveFilePtr==NULL){
       printf("Can not create file: %s", SaveFileName);
       return;
   }
   fprintf(SaveFilePtr, "%u\n", Paint->x);
   fprintf(SaveFilePtr, "%u\n", Paint->y);
   for(long cy=0; cy < Paint->y; cy++){
       for(long cx=0; cx < Paint->x; cx++){
	   fprintf(SaveFilePtr, "%u  ", Paint->Cell[cx][cy]);
       }
       fprintf(SaveFilePtr, "\n");
   }
   fclose(SaveFilePtr);
   return;
}
void SaveBmpFile(char* SaveFileName){
   ABITMAPFILEHEADER bmpfh;
   ABITMAPINFO bmpi;
   ABITMAPINFOHEADER* pbmpih;
   ARGBQUAD* colors;
   int xsize = Paint->x;
   int ysize = Paint->y;
   FILE* SaveFilePtr=fopen(SaveFileName, "wb");
   if(SaveFilePtr==NULL){
       printf("Can not create file: %s", SaveFileName);
       return;
   }
   bmpfh.bfType='BM';
   bmpfh.bfSize=sizeof(ABITMAPFILEHEADER)+sizeof(ABITMAPINFO) + xsize*ysize;
   bmpfh.bfReserved1=0;
   bmpfh.bfReserved2=0;
   bmpfh.bfOffBits=sizeof(ABITMAPFILEHEADER)+sizeof(ABITMAPINFO);

   pbmpih=&bmpi.bmiHeader;
   pbmpih->biSize=sizeof(ABITMAPINFOHEADER);
   pbmpih->biWidth=xsize;
   pbmpih->biHeight=ysize;
   pbmpih->biPlanes=1;
   pbmpih->biBitCount=8;
   pbmpih->biCompression=BI_RGB;
   pbmpih->biSizeImage=xsize*ysize;
   pbmpih->biXPelsPerMeter=4730;
   pbmpih->biYPelsPerMeter=4720;
   pbmpih->biClrUsed=0;
   pbmpih->biClrImportant=0;

   colors=bmpi.bmiColors;
   for(int i=0; i<256; i++){
       //ARGBQUAD RGB;
       //wgetrgb(i, &RGB);
       //colors[i] = RGB;
       colors[i] = Paint->Palette[i];
   }
   fwrite(&bmpfh, sizeof(bmpfh), 1, SaveFilePtr);
   fflush(SaveFilePtr);
   fwrite(&bmpi, sizeof(bmpi), 1, SaveFilePtr);
   for(int y = Paint->y - 1; y>=0; y-- ){
       for(int x=0; x < Paint->x; x++){
	   char c = Paint->Cell[x][y];
	   fwrite( &c, 1, 1, SaveFilePtr );
       }
       while( x%4 != 0 ){
	   fwrite( 0, 1, 1, SaveFilePtr );
	   x++;
       }
   }
   fclose(SaveFilePtr);
   return;
}
void LoadPicFile(char* LoadFileName){
   int NewX=0, NewY=0;
   FILE* LoadFilePtr=NULL;
   LoadFilePtr=fopen(LoadFileName, "rt");
   fscanf(LoadFilePtr, "%u", &NewX);
   fscanf(LoadFilePtr, "%u", &NewY);
   if(NewX<=0 || NewY<=0){
       ErrorMsg("Not a PIC file format");
       return;
   }
   delete Paint;
   Paint=new PaintClass(NewX, NewY);
   for(long cy=0; cy<Paint->y; cy++){
       for(long cx=0; cx<Paint->x; cx++){
	   fscanf(LoadFilePtr, "%u", &Paint->Cell[cx][cy]);
       }
   }
   fclose(LoadFilePtr);
   return;
}
void LoadBmpFile(char* LoadFileName){
   ABITMAPFILEHEADER bmpfh;
   ABITMAPINFO bmpi;
   //ABITMAPINFOHEADER* pbmpih;
   ARGBQUAD c;
   int colors[256];
   int NewX, NewX_DWORD, NewY, i, mincolor, min_dif;
   FILE* LoadFilePtr=NULL;
   char* buf=NULL;
   LoadFilePtr=fopen(LoadFileName, "rb");
   int Readed = fread(&bmpfh, sizeof(bmpfh), 1, LoadFilePtr);
   if(bmpfh.bfType!='BM' || !Readed){
       ErrorMsg("Not a BMP file format");
       return;
   }
   Readed = fread(&bmpi, sizeof(bmpi), 1, LoadFilePtr);
   NewX = bmpi.bmiHeader.biWidth;
   NewY = bmpi.bmiHeader.biHeight;

   if(NewX<=0 || NewY<=0  || !Readed){
       ErrorMsg("Not a BMP file format");
       return;
   }
   if(bmpi.bmiHeader.biBitCount != 8){
       ErrorMsg("Sorry, not a 8-bit BMP");
       return;
   }
   if(NewX%4 != 0) NewX_DWORD = (NewX/4 + 1)*4;
   else NewX_DWORD = NewX;

   buf = new char[NewX_DWORD*NewY];
   if(buf==NULL){
       ErrorMsg("Sorry, not enough memory");
       return;
   }
   Readed = fread(buf, NewX_DWORD*NewY, 1, LoadFilePtr);
   if(!Readed){
       ErrorMsg("Not a BMP file format");
       return;
   }
   delete Paint;
   Paint=new PaintClass(NewX, NewY);

   //make palette
   for(i=0; i<256; i++){
       c = Paint->Palette[0];
       min_dif = abs(bmpi.bmiColors[i].rgbRed - c.rgbRed) + abs(bmpi.bmiColors[i].rgbGreen  - c.rgbGreen) + abs(bmpi.bmiColors[i].rgbBlue  - c.rgbBlue);
       mincolor = 0;
       for(int k=0; k<256; k++){
           c = Paint->Palette[k];
           long dif = abs(bmpi.bmiColors[i].rgbRed - c.rgbRed) + abs(bmpi.bmiColors[i].rgbGreen  - c.rgbGreen) + abs(bmpi.bmiColors[i].rgbBlue - c.rgbBlue);
           if(dif<min_dif){
               min_dif = dif;
               mincolor = k;
           }
       }
       colors[i] = mincolor;
   }
   i=0;
   for(int cy=Paint->y-1; cy>=0; cy--){
       for(int cx=0; cx<Paint->x; cx++){
           Paint->Cell[cx][cy] = colors[ buf[i] ];
           i++;
       }
       while(i%4) i++;
   }
   delete [] buf;
   fclose(LoadFilePtr);
   return;
}
//------------------------------------------------------------------------
void Input(char* Title, int* Result){
   wsetcolor(WHITE);
   wrectangle( (Maxx-InputWindowLength)/2, (Maxy-InputWindowWidth)/2, (Maxx+InputWindowLength)/2, (Maxy+InputWindowWidth)/2);
   wsetcolor(RED);
   wbar( (Maxx-InputWindowLength)/2+1, (Maxy-InputWindowWidth)/2+1, (Maxx+InputWindowLength)/2-1, (Maxy+InputWindowWidth)/2-1);
   wsetcolor(WHITE);
   wouttextxy( Maxx/2-wgettextwidth(Title, NULL)/2, (Maxy-InputWindowWidth)/2+InputWindowWidth/6, Title, NULL);
   Edit(Result, Maxx/2, Maxy/2, InputWindowLength, InputWindowWidth/3);
}
//------------------------------------------------------------------------
void Input(char* Title, char* Result){
   wsetcolor(WHITE);
   wrectangle( (Maxx-InputWindowLength)/2, (Maxy-InputWindowWidth)/2, (Maxx+InputWindowLength)/2, (Maxy+InputWindowWidth)/2);
   wsetcolor(RED);
   wbar( (Maxx-InputWindowLength)/2+1, (Maxy-InputWindowWidth)/2+1, (Maxx+InputWindowLength)/2-1, (Maxy+InputWindowWidth)/2-1);
   wsetcolor(WHITE);
   wouttextxy( Maxx/2-wgettextwidth( Title ,NULL)/2, (Maxy-InputWindowWidth)/2+InputWindowWidth/6, Title, NULL);
   Edit(Result, Maxx/2, Maxy/2, InputWindowLength, InputWindowWidth/3);
}
//------------------------------------------------------------------------
void New(){
   delete Paint;
   int NewX=0, NewY=0;
   Input("Input X size", &NewX);
   Input("Input Y size", &NewY);
   Paint=new PaintClass(NewX, NewY);
   return;
}
//----------------------------------------------------------------------
void DrawColorBar(){
   int currentcolor=0;
   wsetcolor(WHITE);
   wrectangle(Maxx-ColorBarWidth-1, Maxy-ColorBarWidth-1, Maxx, Maxy);
   for(int cx=Maxx-ColorBarWidth; cx<=Maxx-4; cx+=ColorBarCellSize){
       for(int cy=Maxy-ColorBarWidth; cy<=Maxy-4; cy+=ColorBarCellSize , currentcolor++){
	   wsetcolor(currentcolor);
	   wbar(cx, cy, cx+ColorBarCellSize-1, cy+ColorBarCellSize-1);
       }
   }
   return;
}
void DrawKeyLine(){
   char FirstKey[2];
   for(int i=0; i<KeyNums; i++){
       FirstKey[0]=Keys[i][0];
       FirstKey[1]='\0';
       wsetcolor(LIGHTRED);
       wouttextxy(i*KeyLength, Maxy-wgettextheight("A", NULL) , FirstKey, NULL);
       wsetcolor(WHITE);
       wouttextxy(i*KeyLength+wgettextwidth("A", NULL ), Maxy-wgettextheight("A", NULL), &Keys[i][1], NULL);
   }
   wouttextxy(i*KeyLength, Maxy-wgettextheight(FirstKey, NULL), FileTypeName[FileType], NULL );
}
void DrawDefinedColorBar(){
   wsetcolor(WHITE);
   for(int cx=0; cx<=4; cx++){
       wfline(Maxx-cx*ColorBarWidth/4-1, Maxy-2*ColorBarWidth-1, Maxx-cx*ColorBarWidth/4-1 , Maxy-ColorBarWidth-1);
   }
   for(int cy=0; cy<=4; cy++){
       wfline(Maxx-ColorBarWidth-1, Maxy-2*ColorBarWidth+cy*ColorBarWidth/4-1, Maxx-1, Maxy-2*ColorBarWidth+cy*ColorBarWidth/4-1);
   }
   int k=0;
   for( cx=0; cx<4; cx++){
       for( cy=0; cy<4; cy++){
	   wsetcolor( DefinedColor[k] );
           wbar( Maxx-ColorBarWidth+cx*ColorBarWidth/4,
                 Maxy-2*ColorBarWidth+cy*ColorBarWidth/4,
                 Maxx-ColorBarWidth+(cx+1)*ColorBarWidth/4-2,
                 Maxy-2*ColorBarWidth+(cy+1)*ColorBarWidth/4-2
                 );
	   k++;
       }
   }
}
//----------------------------------------------------------------------
void Edit(int* Result, int XCenter, int YCenter, int Length, int Width){
   char key=0;
   char String[256]="";
   int CursorPosition=0;
   while(1){
       if(bioskey(1)!=0){
	   key=bioskey(0);
	   if( key>='0' && key<='9'){
	       String[CursorPosition]=key;
	       String[CursorPosition+1]='\0';
	       CursorPosition++;
	       wsetcolor(RED);
	       wbar(XCenter-Length/2+1, YCenter-Width/2+1, XCenter+Length/2-1, YCenter+Width/2-1);
	       wsetcolor(WHITE);
	       wouttextxy(XCenter-wgettextwidth(String, NULL)/2, YCenter-wgettextheight(String, NULL)/2, String, NULL);
	   }
	   if(key==8){
	       if(CursorPosition>0){
		   String[CursorPosition-1]='\0';
		   CursorPosition-- ;
		   wsetcolor(RED);
		   wbar(XCenter-Length/2+1, YCenter-Width/2+1, XCenter+Length/2-1, YCenter+Width/2-1);
                   wsetcolor(WHITE);
		   wouttextxy(XCenter-wgettextwidth(String, NULL)/2, YCenter-wgettextheight(String, NULL)/2, String, NULL);
	       }
	   }
	   if(key==13){
	       *Result=atoi(String);
	       return;
	   }
       }
   }
}
void Edit(char* ResultString, int XCenter, int YCenter, int Length, int Width){
   int CursorPosition=0;
   while(1){
       if(bioskey(1)!=0){
	   char key=bioskey(0);
	   if(key==13) return;
	   if(key==8 && CursorPosition>0){
	       ResultString[CursorPosition-1]='\0';
	       CursorPosition-- ;
	       wsetcolor(RED);
	       wbar(XCenter-Length/2+1, YCenter-Width/2+1, XCenter+Length/2-1, YCenter+Width/2-1);
	       wsetcolor(WHITE);
	       wouttextxy(XCenter-wgettextwidth(ResultString, NULL)/2, YCenter-wgettextheight(ResultString, NULL)/2, ResultString, NULL);
	   }
	   else{
	       ResultString[CursorPosition]=key;
	       ResultString[CursorPosition+1]='\0';
	       CursorPosition++;
	       wsetcolor(RED);
	       wbar(XCenter-Length/2+1, YCenter-Width/2+1, XCenter+Length/2-1, YCenter+Width/2-1);
	       wsetcolor(WHITE);
	       wouttextxy(XCenter-wgettextwidth(ResultString, NULL)/2, YCenter-wgettextheight(ResultString, NULL)/2, ResultString, NULL);
	   }
       }
   }
}
//-----------------------------------------------------------------------
//calculate dif time in seconds
float DifferenceTime(struct time* Begin, struct time* End){
   float BeginTime=Begin->ti_min*60 + Begin->ti_hour*60*60 + Begin->ti_sec + Begin->ti_hund*0.01;
   float EndTime=End->ti_min*60 + End->ti_hour*60*60 + End->ti_sec + End->ti_hund*0.01;
   return(EndTime-BeginTime);
}
void ChangeFileType(){
   moff();
   if(FileType==FileTypeNumber-1){
       FileType=0;
   }
   else FileType++;
   wsetcolor(BLACK);
   wbar( KeyLength*(KeyNums),
         Maxy-wgettextheight("A", NULL),
         KeyLength*(KeyNums)+wgettextwidth( FileTypeName[FileType], NULL ),
         Maxy);
   DrawKeyLine();
   delay(100);
   mon();
}
//------------------------------------------------------------------------
void main(/*int NumArgs, char** MainArgs*/){
   /*char* bitmap;
   int is;*/
   vga256();
   wgetpalette( &Paint->Palette[0] );
   minit();
   mon();
   int N=20;
   Paint=new PaintClass(N, N);
   clear_keyboard_buffer();
   Paint->RefreshScreen();
   /*is = wimagesize(0, 0, 10, 10);
   bitmap = new char[is];
   wgetimage(0,0,10,10, bitmap);
   wputimage(280, 180, bitmap, NOT_PUT);
   getch();*/

   int exit_condition=0;
   while(!exit_condition){
       if(inp(96)==1 ) exit_condition=1;
       mread();
       if(but==1){                            //but is the state of buttons
	   int cx=mx/Paint->CellSize;
	   int cy=my/Paint->CellSize;
	   //To draw on maximized field
	   if(mx>=0 && mx<Paint->CellSize*Paint->x && mx < Paint->CellSize * MaxXCellsVisible
	   && my>=0 && my<Paint->CellSize*Paint->y && my < Paint->CellSize * MaxYCellsVisible ){
               if(Paint->Cell[cx][cy] != Paint->CurrentColor){
	           Paint->Cell[cx][cy]=Paint->CurrentColor;
		   moff();

	           wsetcolor( Paint->Cell[cx][cy] );
	           wbar(cx*Paint->CellSize, cy*Paint->CellSize, (cx*Paint->CellSize+Paint->CellSize-2), (cy*Paint->CellSize+Paint->CellSize-2) );
	           wsetcolor( Paint->Cell[cx][cy]);
		   wfastputpixel(Paint->MinimizedLeft+cx, Paint->MinimizedTop+cy);

	           mon();
               }
	   }
	   //To select color from 256
	   if(mx>=Maxx-ColorBarWidth && my>=Maxy-ColorBarWidth){
	       int xcolor=(mx+ColorBarWidth-Maxx)/ColorBarCellSize;
	       int ycolor=(my+ColorBarWidth-Maxy)/ColorBarCellSize;
	       Paint->CurrentColor = xcolor*16 + ycolor;
	   }
	   //To change file type
	   if(mx>=KeyLength*(KeyNums) && mx<KeyLength*(KeyNums+1) && my>=Maxy-wgettextheight("A", NULL) ){
               ChangeFileType();
	   }
           //to Exit by mouse
           if(mx>=0 && mx<KeyLength && my>=Maxy-wgettextheight("A", NULL)){
               exit_condition=1;
           }
           //to Save by mouse
           if(mx>=KeyLength && mx<2*KeyLength && my>=Maxy-wgettextheight("A", NULL)){
	       moff();
	       Paint->Save();
	       Paint->RefreshScreen();
	       mon();
           }
           //to Load by mouse
           if(mx>=2*KeyLength && mx<3*KeyLength && my>=Maxy-wgettextheight("A", NULL)){
	       moff();
	       Paint->Load();
	       Paint->RefreshScreen();
	       mon();
           }
           //to New by mouse
           if(mx>=3*KeyLength && mx<4*KeyLength && my>=Maxy-wgettextheight("A", NULL)){
	       moff();
	       New();
	       mon();
           }
	   //To select color from 16 DefinedColor
	   if(mx>Maxx-ColorBarWidth && my>Maxy-2*ColorBarWidth && my<Maxy-ColorBarWidth){
	       delay(200);
	       int cx=float(mx-Maxx+ColorBarWidth)/float(ColorBarWidth)*4.0;
	       int cy=float(my-Maxy+2*ColorBarWidth)/float(ColorBarWidth)*4.0;

	       //To select color
	       Paint->CurrentColor = DefinedColor[cx*4+cy];
	   }
       }
       if( bioskey(1)!=0 ){
	   char key=bioskey(0);
	   key=tolower(key);
	   switch(key){
	       case 'n':
		   moff();
		   New();
		   mon();
		   break;
	       case 's':
		   moff();
		   Paint->Save();
		   Paint->RefreshScreen();
		   mon();
		   break;
	       case 'l':
		   moff();
		   Paint->Load();
		   Paint->RefreshScreen();
		   mon();
		   break;
	       case 'e':
		   exit_condition=1;
		   break;
               case '\t':
                   ChangeFileType();
                   break;
	   }//end switch
       }//end if(bioskey(1)!=0)
   }//end while(1)
   moff();
   textmode(C80);
}